# coding: utf-8

"""
    Internal API

    SmartDiagnostics REST API for internal users only  # noqa: E501

    OpenAPI spec version: v3
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from smart_diagnostics_client.api_client import ApiClient


class RepeatersApi(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def get_repeater(self, **kwargs):  # noqa: E501
        """Get receivers subject to query options  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_repeater(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str filter: Filter statements to narrow results by properties. Filterable properties:  | Field name | Type | Operators | | ---------- | ---- | --------- | | `Active` | Boolean | `eq, neq` | | `CorporationName` | String | `eq, neq, like, in` | | `Id` | Int64 | `eq, neq, in, lt, gt, leq, geq` | | `LastStatusUpdate` | DateTime? | `eq, neq, in, lt, gt, leq, geq` | | `LocationId` | Guid? | `eq, neq, in, lt, gt, leq, geq` | | `LocationName` | String | `eq, neq, like, in` | | `RadioMacAddress` | String | `eq, neq, like, in` | | `SerialNumber` | String | `eq, neq, like, in` | | `Type` | ReceiverLocationTypeCodes | `eq, neq, in` |
        :param int page: Results page. 1-based (1 returns the first page, 0 is invalid).
        :param int page_limit: Number of items to return per page.
        :param str order_by: Allows sorting response items by multiple fields. Sortable properties: | Field name | Type | | ---------- | ---- | | `Active` | Boolean | | `CorporationId` | Guid? | | `CorporationName` | String | | `Id` | Int64 | | `LastStatusUpdate` | DateTime? | | `LocationId` | Guid? | | `LocationName` | String | | `RadioMacAddress` | String | | `SerialNumber` | String | | `Type` | ReceiverLocationTypeCodes |
        :param str name_search: Provide search terms to narrow result.  Searchable properties: `CorporationName`, `LocationName`, `RadioMacAddress`, `SerialNumber`.
        :return: PagedResultsModelRepeaterModelV3
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_repeater_with_http_info(**kwargs)  # noqa: E501
        else:
            (data) = self.get_repeater_with_http_info(**kwargs)  # noqa: E501
            return data

    def get_repeater_with_http_info(self, **kwargs):  # noqa: E501
        """Get receivers subject to query options  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_repeater_with_http_info(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str filter: Filter statements to narrow results by properties. Filterable properties:  | Field name | Type | Operators | | ---------- | ---- | --------- | | `Active` | Boolean | `eq, neq` | | `CorporationName` | String | `eq, neq, like, in` | | `Id` | Int64 | `eq, neq, in, lt, gt, leq, geq` | | `LastStatusUpdate` | DateTime? | `eq, neq, in, lt, gt, leq, geq` | | `LocationId` | Guid? | `eq, neq, in, lt, gt, leq, geq` | | `LocationName` | String | `eq, neq, like, in` | | `RadioMacAddress` | String | `eq, neq, like, in` | | `SerialNumber` | String | `eq, neq, like, in` | | `Type` | ReceiverLocationTypeCodes | `eq, neq, in` |
        :param int page: Results page. 1-based (1 returns the first page, 0 is invalid).
        :param int page_limit: Number of items to return per page.
        :param str order_by: Allows sorting response items by multiple fields. Sortable properties: | Field name | Type | | ---------- | ---- | | `Active` | Boolean | | `CorporationId` | Guid? | | `CorporationName` | String | | `Id` | Int64 | | `LastStatusUpdate` | DateTime? | | `LocationId` | Guid? | | `LocationName` | String | | `RadioMacAddress` | String | | `SerialNumber` | String | | `Type` | ReceiverLocationTypeCodes |
        :param str name_search: Provide search terms to narrow result.  Searchable properties: `CorporationName`, `LocationName`, `RadioMacAddress`, `SerialNumber`.
        :return: PagedResultsModelRepeaterModelV3
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['filter', 'page', 'page_limit', 'order_by', 'name_search']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_repeater" % key
                )
            params[key] = val
        del params['kwargs']

        collection_formats = {}

        path_params = {}

        query_params = []
        if 'filter' in params:
            query_params.append(('Filter', params['filter']))  # noqa: E501
        if 'page' in params:
            query_params.append(('Page', params['page']))  # noqa: E501
        if 'page_limit' in params:
            query_params.append(('PageLimit', params['page_limit']))  # noqa: E501
        if 'order_by' in params:
            query_params.append(('OrderBy', params['order_by']))  # noqa: E501
        if 'name_search' in params:
            query_params.append(('NameSearch', params['name_search']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['text/plain', 'application/json', 'text/json'])  # noqa: E501

        # Authentication setting
        auth_settings = []  # noqa: E501

        return self.api_client.call_api(
            '/api/v3.0/Repeaters', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='PagedResultsModelRepeaterModelV3',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)
