# coding: utf-8

"""
    Internal API

    SmartDiagnostics REST API for internal users only  # noqa: E501

    OpenAPI spec version: v3
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class UserUpdateRequest(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'email': 'str',
        'is_approved': 'bool',
        'application_role_code': 'ApplicationRoleCode',
        'corporations': 'list[UserRequestCorporationChild]',
        'locations': 'list[UserRequestLocationChild]',
        'first_name': 'str',
        'last_name': 'str',
        'phone_number': 'str',
        'phone_confirmation_code': 'str'
    }

    attribute_map = {
        'email': 'Email',
        'is_approved': 'IsApproved',
        'application_role_code': 'ApplicationRoleCode',
        'corporations': 'Corporations',
        'locations': 'Locations',
        'first_name': 'FirstName',
        'last_name': 'LastName',
        'phone_number': 'PhoneNumber',
        'phone_confirmation_code': 'PhoneConfirmationCode'
    }

    def __init__(self, email=None, is_approved=None, application_role_code=None, corporations=None, locations=None, first_name=None, last_name=None, phone_number=None, phone_confirmation_code=None):  # noqa: E501
        """UserUpdateRequest - a model defined in Swagger"""  # noqa: E501
        self._email = None
        self._is_approved = None
        self._application_role_code = None
        self._corporations = None
        self._locations = None
        self._first_name = None
        self._last_name = None
        self._phone_number = None
        self._phone_confirmation_code = None
        self.discriminator = None
        self.email = email
        self.is_approved = is_approved
        self.application_role_code = application_role_code
        if corporations is not None:
            self.corporations = corporations
        if locations is not None:
            self.locations = locations
        self.first_name = first_name
        self.last_name = last_name
        if phone_number is not None:
            self.phone_number = phone_number
        if phone_confirmation_code is not None:
            self.phone_confirmation_code = phone_confirmation_code

    @property
    def email(self):
        """Gets the email of this UserUpdateRequest.  # noqa: E501

        User's email  # noqa: E501

        :return: The email of this UserUpdateRequest.  # noqa: E501
        :rtype: str
        """
        return self._email

    @email.setter
    def email(self, email):
        """Sets the email of this UserUpdateRequest.

        User's email  # noqa: E501

        :param email: The email of this UserUpdateRequest.  # noqa: E501
        :type: str
        """
        if email is None:
            raise ValueError("Invalid value for `email`, must not be `None`")  # noqa: E501

        self._email = email

    @property
    def is_approved(self):
        """Gets the is_approved of this UserUpdateRequest.  # noqa: E501

        If the user is approved to access SmartDiagnostics or not. Requester must be a corporation or  location level admin to edit.  # noqa: E501

        :return: The is_approved of this UserUpdateRequest.  # noqa: E501
        :rtype: bool
        """
        return self._is_approved

    @is_approved.setter
    def is_approved(self, is_approved):
        """Sets the is_approved of this UserUpdateRequest.

        If the user is approved to access SmartDiagnostics or not. Requester must be a corporation or  location level admin to edit.  # noqa: E501

        :param is_approved: The is_approved of this UserUpdateRequest.  # noqa: E501
        :type: bool
        """
        if is_approved is None:
            raise ValueError("Invalid value for `is_approved`, must not be `None`")  # noqa: E501

        self._is_approved = is_approved

    @property
    def application_role_code(self):
        """Gets the application_role_code of this UserUpdateRequest.  # noqa: E501


        :return: The application_role_code of this UserUpdateRequest.  # noqa: E501
        :rtype: ApplicationRoleCode
        """
        return self._application_role_code

    @application_role_code.setter
    def application_role_code(self, application_role_code):
        """Sets the application_role_code of this UserUpdateRequest.


        :param application_role_code: The application_role_code of this UserUpdateRequest.  # noqa: E501
        :type: ApplicationRoleCode
        """
        if application_role_code is None:
            raise ValueError("Invalid value for `application_role_code`, must not be `None`")  # noqa: E501

        self._application_role_code = application_role_code

    @property
    def corporations(self):
        """Gets the corporations of this UserUpdateRequest.  # noqa: E501

        The corporations the user belongs to. Saas users should not belong to any corporations  # noqa: E501

        :return: The corporations of this UserUpdateRequest.  # noqa: E501
        :rtype: list[UserRequestCorporationChild]
        """
        return self._corporations

    @corporations.setter
    def corporations(self, corporations):
        """Sets the corporations of this UserUpdateRequest.

        The corporations the user belongs to. Saas users should not belong to any corporations  # noqa: E501

        :param corporations: The corporations of this UserUpdateRequest.  # noqa: E501
        :type: list[UserRequestCorporationChild]
        """

        self._corporations = corporations

    @property
    def locations(self):
        """Gets the locations of this UserUpdateRequest.  # noqa: E501

        The locations the user belongs to. Saas users should not belong to any locations  # noqa: E501

        :return: The locations of this UserUpdateRequest.  # noqa: E501
        :rtype: list[UserRequestLocationChild]
        """
        return self._locations

    @locations.setter
    def locations(self, locations):
        """Sets the locations of this UserUpdateRequest.

        The locations the user belongs to. Saas users should not belong to any locations  # noqa: E501

        :param locations: The locations of this UserUpdateRequest.  # noqa: E501
        :type: list[UserRequestLocationChild]
        """

        self._locations = locations

    @property
    def first_name(self):
        """Gets the first_name of this UserUpdateRequest.  # noqa: E501

        The user's first name  # noqa: E501

        :return: The first_name of this UserUpdateRequest.  # noqa: E501
        :rtype: str
        """
        return self._first_name

    @first_name.setter
    def first_name(self, first_name):
        """Sets the first_name of this UserUpdateRequest.

        The user's first name  # noqa: E501

        :param first_name: The first_name of this UserUpdateRequest.  # noqa: E501
        :type: str
        """
        if first_name is None:
            raise ValueError("Invalid value for `first_name`, must not be `None`")  # noqa: E501

        self._first_name = first_name

    @property
    def last_name(self):
        """Gets the last_name of this UserUpdateRequest.  # noqa: E501

        The user's last name  # noqa: E501

        :return: The last_name of this UserUpdateRequest.  # noqa: E501
        :rtype: str
        """
        return self._last_name

    @last_name.setter
    def last_name(self, last_name):
        """Sets the last_name of this UserUpdateRequest.

        The user's last name  # noqa: E501

        :param last_name: The last_name of this UserUpdateRequest.  # noqa: E501
        :type: str
        """
        if last_name is None:
            raise ValueError("Invalid value for `last_name`, must not be `None`")  # noqa: E501

        self._last_name = last_name

    @property
    def phone_number(self):
        """Gets the phone_number of this UserUpdateRequest.  # noqa: E501

        User's phone number, formatted as (###) ###-####  # noqa: E501

        :return: The phone_number of this UserUpdateRequest.  # noqa: E501
        :rtype: str
        """
        return self._phone_number

    @phone_number.setter
    def phone_number(self, phone_number):
        """Sets the phone_number of this UserUpdateRequest.

        User's phone number, formatted as (###) ###-####  # noqa: E501

        :param phone_number: The phone_number of this UserUpdateRequest.  # noqa: E501
        :type: str
        """

        self._phone_number = phone_number

    @property
    def phone_confirmation_code(self):
        """Gets the phone_confirmation_code of this UserUpdateRequest.  # noqa: E501

        Confirmation code from text message sent to user's phone. Must be included if changing a user's PhoneNumber  # noqa: E501

        :return: The phone_confirmation_code of this UserUpdateRequest.  # noqa: E501
        :rtype: str
        """
        return self._phone_confirmation_code

    @phone_confirmation_code.setter
    def phone_confirmation_code(self, phone_confirmation_code):
        """Sets the phone_confirmation_code of this UserUpdateRequest.

        Confirmation code from text message sent to user's phone. Must be included if changing a user's PhoneNumber  # noqa: E501

        :param phone_confirmation_code: The phone_confirmation_code of this UserUpdateRequest.  # noqa: E501
        :type: str
        """

        self._phone_confirmation_code = phone_confirmation_code

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(UserUpdateRequest, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, UserUpdateRequest):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
